
/*
** (c) 2003 Herbert Poetzl
**
** V0.01	test for syscall
**
*/

#define VERSION "V0.01"

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <signal.h>
#include <syscall.h>
#include <asm/unistd.h>
#include <unistd.h>
#include <sched.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/mount.h>

 
#include "virtual.h"


static	char	err_flag = 0;

static	char	opt_kill = 0;
static	char	opt_vers = 0;

static	char *	cmd_name = NULL;

static	int 	num_pid = 0;
static	int 	num_ctx = 0;
static	int 	num_sig = 15;


#define OPTIONS "+hk:p:x:V"

int	main(int argc, char *argv[])
{
        extern int optind;
        extern char *optarg;
        char c, errflg = 0;
	int r;


        cmd_name = argv[0];
        while ((c = getopt(argc, argv, OPTIONS)) != EOF) {
            switch (c) {
            case 'h':
                fprintf(stderr,
                    "This is %s " VERSION "\n"
                    "options are:\n"
                    "-h        print this help message\n"
                    "-k <num>  kill (signal num)\n"
                    "-p <num>  target pid (def. 0)\n"
                    "-x <num>  context id\n"
                    "-V        verify interface version\n"
                    "--        end of options\n"
                    ,cmd_name);
                exit(0);
                break;
            case 'k':
                num_sig = atol(optarg);
                opt_kill = 1;
                break;
            case 'p':
                num_pid = atol(optarg);
                break;
            case 'x':
                num_ctx = atol(optarg);
                break;
            case 'V':
                opt_vers = 1;
                break;
            case '?':
            default:
                errflg++;
                break;
            }
        }
        if (errflg) {
            fprintf(stderr, 
                "Usage: %s -[" OPTIONS "]\n"
                "%s -h for help.\n",
                cmd_name, cmd_name);
            exit(2);
        }

	if (opt_vers) {
	    r = vserver(VCMD_get_version, 0, NULL);
	    if (r<0)
	    	perror("vc_get_version");
    	    else 
	    	printf("version: %04x:%04x\n", 
		    (r>>16)&0xFFFF, r&0xFFFF);
	}

	if (opt_kill) {
	    struct vcmd_ctx_kill_v0 data = { 0,0 };
	    
	    data.pid = num_pid;
	    data.sig = num_sig;
	    
	    r = vserver(VCMD_ctx_kill, num_ctx, &data);
	    if (r)
	    	perror("vc_ctx_kill");
	}
	
	exit((err_flag)?1:0);
}

